
#ifndef __HSCAL_CB_ZHER_HH
#define __HSCAL_CB_ZHER_HH



#include "../../../../include/hscalapack.h"

int hscal_zher(
    char *uplo,
    int  *n, 
    char *calpha,
    int  *incx, 
    int  *lda, 
    double  *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5;
    int info;
    int i__, j;
    hscaldoublereal * alpha = (hscaldoublereal*)calpha;

    info   = 0;
    *tcomp = 0;
    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*lda < max(1,*n)) {
	info = 7;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*n == 0 || *alpha == 0.) {
	return HSCAL_SUCCESS;
    }
    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 7;
		    i__2 = j - 1;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                        *tcomp += 14;
		    }
                    *tcomp += 13;
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 7;
		    i__2 = j - 1;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                        *tcomp += 15;
		    }
                    *tcomp += 13;
		}
                *tcomp += 1;
	    }
	}
    } else {
	if (*incx == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 20;
		    i__2 = *n;
		    for (i__ = j + 1; i__ <= i__2; ++i__) {
                        *tcomp += 14;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 20;
		    i__2 = *n;
		    for (i__ = j + 1; i__ <= i__2; ++i__) {
                        *tcomp += 15;
		    }
		}
                *tcomp += 1;
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
