
#ifndef __HSCAL_PTZB_CMMDDACT_HSCALFUNC_HH
#define __HSCAL_PTZB_CMMDDACT_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_cmmddact(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscalcomplex *alpha = (hscalcomplex*)calpha;
hscalcomplex *beta = (hscalcomplex*)cbeta;
*tcomp = 0;

{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4;
    int i__, j;

    if (*m >= *n) {
	if (beta->r == 1.f && beta->i == 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += *n * *m * 9;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += *n * *m * 19;
	    } else {
                *tcomp += *n * *m * 13;
	    }
	} else if (beta->r != 0.f || beta->i != 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += *n * *m * 15;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += *n * *m * 25;
	    } else {
                *tcomp += *n * *m * 19;
	    }
	} else {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += *n * *m * 4;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
		hscal_cscal(
                     m, calpha, &c__1,
                     tcomp
                );
                *tcomp *= *n;
	    }
	}
    } else {
	if (beta->r == 1.f && beta->i == 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += *n * *m * 9;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += *n * *m * 19;
	    } else {
                *tcomp += *n * *m * 13;
	    }
	} else if (beta->r != 0.f || beta->i != 0.f) {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += *n * *m * 15;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
                *tcomp += *n * *m * 25;
	    } else {
                *tcomp += *n * *m * 19;
	    }
	} else {
	    if (alpha->r == 0.f && alpha->i == 0.f) {
                *tcomp += *n * *m * 4;
	    } else if (alpha->r != 1.f || alpha->i != 0.f) {
	        hscal_cscal(
                     m, calpha, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	}
    }

    return HSCAL_SUCCESS;
}
}

#endif
