
#ifndef __HSCAL_PTZB_CMMTCADD_HSCALFUNC_HH
#define __HSCAL_PTZB_CMMTCADD_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_cmmtcadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
hscalcomplex *alpha = (hscalcomplex*)calpha;
hscalcomplex *beta = (hscalcomplex*)cbeta;
int c__1 = 1;

*tcomp = 0;
{
    if (*m >= *n) {
	if (alpha->r == 1.f && alpha->i == 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += *n * *m * 9;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += *n * *m * 19;
	    } else {
                *tcomp += *n * *m * 13;
	    }
	} else if (alpha->r != 0.f || alpha->i != 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += *n * *m * 15;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += *n * *m * 25;
	    } else {
                *tcomp += *n * *m * 19;
	    }
	} else {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += *n * *m * 4;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                hscal_cscal(
                     n, cbeta, &c__1, tcomp
                );
                *tcomp *= *m;
	    }
	}
    } else {
	if (alpha->r == 1.f && alpha->i == 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += *n * *m * 9;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += *n * *m * 19;
	    } else {
                *tcomp += *n * *m * 13;
	    }
	} else if (alpha->r != 0.f || alpha->i != 0.f) {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += *n * *m * 15;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                *tcomp += *n * *m * 25;
	    } else {
                *tcomp += *n * *m * 19;
	    }
	} else {
	    if (beta->r == 0.f && beta->i == 0.f) {
                *tcomp += *n * *m * 4;
	    } else if (beta->r != 1.f || beta->i != 0.f) {
                hscal_cscal(
                     n, cbeta, &c__1, tcomp
                );
                *tcomp *= *m;
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

