
#ifndef __HSCAL_PTZB_ZMMCADD_HSCALFUNC_HH
#define __HSCAL_PTZB_ZMMCADD_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_zmmcadd(
    int *m, 
    int *n, 
    char *calpha,
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
hscaldoublecomplex *beta = (hscaldoublecomplex*)cbeta;

*tcomp = 0;
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4;
    int i__, j;
    if (alpha->r == 1. && alpha->i == 0.) {
	if (beta->r == 0. && beta->i == 0.) {
            *tcomp += (*n * *m * 9);
	} else if (beta->r != 1. || beta->i != 0.) {
            *tcomp += (*n * *m * 19);
	} else {
            *tcomp += (*n * *m * 13);
	}
    } else if (alpha->r != 0. || alpha->i != 0.) {
	if (beta->r == 0. && beta->i == 0.) {
            *tcomp += (*n * *m * 15);
	} else if (beta->r != 1. || beta->i != 0.) {
            *tcomp += (*n * *m * 25);
	} else {
            *tcomp += (*n * *m * 19);
	}
    } else {
	if (beta->r == 0. && beta->i == 0.) {
            *tcomp += (*n * *m * 4);
	} else if (beta->r != 1. || beta->i != 0.) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                double t;
		hscal_zscal(
                     m, cbeta, &c__1,
                     &t
                );
                *tcomp += t;
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

