#!/bin/sh

. ./cparameters.sh

PSIZE=10240
P_COUNT=1
NUMBER_OF_P_ITERATIONS=16

while [ "$P_COUNT" -le "$NUMBER_OF_P_ITERATIONS" ]
do
	PSIZE=10240

	Q_COUNT=1
	NUMBER_OF_Q_ITERATIONS=16

	while [ "$Q_COUNT" -le "$NUMBER_OF_Q_ITERATIONS" ]
	do

        let "PRODUCT = $P_COUNT * $Q_COUNT"

        if [ $PRODUCT -gt 16 ]; then
	   break;
        fi

	echo "===============$PSIZE, $P_COUNT, $Q_COUNT===========" >> test_PB_Cnumroc_serial.txt

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > problem_parameters_serial.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> problem_parameters_serial.h
	echo ""                                                     >> problem_parameters_serial.h
	echo "int     M                = $PSIZE;"                   >> problem_parameters_serial.h
	echo "int     N                = $PSIZE;"                   >> problem_parameters_serial.h
	echo "int     MB               = 32;"                       >> problem_parameters_serial.h
	echo "int     NB               = 32;"                       >> problem_parameters_serial.h
	echo "int     IA               = 1;"                        >> problem_parameters_serial.h
	echo "int     JA               = 1;"                        >> problem_parameters_serial.h
        echo "int     nprow            = $P_COUNT;"                 >> problem_parameters_serial.h
        echo "int     npcol            = $Q_COUNT;"                 >> problem_parameters_serial.h
	echo ""                                                     >> problem_parameters_serial.h
	echo "#endif"                                               >> problem_parameters_serial.h

	hscal_execute test_PB_Cnumroc_serial

	let "Q_COUNT = $Q_COUNT + 1"
	done

let "P_COUNT = $P_COUNT + 1"
done
